// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.0 (2006/09/21)

#ifndef WM4IMAGICS_H
#define WM4IMAGICS_H

// binary operations
#include "Wm4Binary2D.h"
#include "Wm4Binary3D.h"

// extraction
#include "Wm4ExtractCurveSquares.h"
#include "Wm4ExtractCurveTris.h"
#include "Wm4ExtractSurfaceCubes.h"
#include "Wm4ExtractSurfaceTetra.h"

// filters
#include "Wm4CurvatureFlow2.h"
#include "Wm4CurvatureFlow3.h"
#include "Wm4FastBlur.h"
#include "Wm4GaussianBlur2.h"
#include "Wm4GaussianBlur3.h"
#include "Wm4GradientAnisotropic2.h"
#include "Wm4GradientAnisotropic3.h"
#include "Wm4PdeFilter.h"
#include "Wm4PdeFilter2.h"
#include "Wm4PdeFilter3.h"

// images
#include "Wm4Element.h"
#include "Wm4ImageConvert.h"
#include "Wm4Images.h"
#include "Wm4Lattice.h"
#include "Wm4TImage.h"
#include "Wm4TImage2D.h"
#include "Wm4TImage3D.h"

// raster drawing
#include "Wm4RasterDrawing.h"

// segmenters
#include "Wm4FastMarch.h"
#include "Wm4FastMarch2.h"
#include "Wm4FastMarch3.h"

#endif
