// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.0 (2006/06/28)

#ifndef WM4PHYSICS_H
#define WM4PHYSICS_H

// intersection
#include "Wm4ExtremalQuery3.h"
#include "Wm4ExtremalQuery3BSP.h"
#include "Wm4ExtremalQuery3PRJ.h"
#include "Wm4IntersectingBoxes.h"
#include "Wm4IntersectingIntervals.h"
#include "Wm4IntersectingRectangles.h"

// LCP solver
#include "Wm4LCPPolyDist.h"
#include "Wm4LCPSolver.h"

// particle systems
#include "Wm4MassSpringArbitrary.h"
#include "Wm4MassSpringCurve.h"
#include "Wm4MassSpringSurface.h"
#include "Wm4MassSpringVolume.h"
#include "Wm4ParticleSystem.h"

// rigid bodies
#include "Wm4PolyhedralMassProperties.h"
#include "Wm4RigidBody.h"

#endif
